%number of clusters
numclus = 3

%read image
img = imread('image.jpg');       
figure;
imshow(img);

[x, y, z] = size(img);           

%Change to 2d 
reimg = reshape(img, x*y, z);     
img = double(img);                
reimg = double(reimg);            

% Apply kmeans1 algorithm 
[distance,label,tse] = kmeans1(reimg, numclus);

%Change back to 3d
origimg = reshape(label, x, y);    
[x, y]=size(origimg); 

%Initialise the mean in each of the cluster in each of the 3 RGB planes 
for i = 1:numclus                
  for j = 1:z                 
  clusmean(i,j) = 0;
  end
cluster(i) = 0;             
end

%calculate the mean value for the color of each region
for i = 1:x
 for j = 1:y
  index = origimg(i,j);         
 for z = 1:3
 %Update mean color of the cluster to which the pixel belongs
 clusmean(index,z) = clusmean(index,z)+img(i,j,z);
 end                        
 %Increment number of pixels in the cluster
  cluster(index) = cluster(index) + 1;
    end                            
end

% Find mean
for i = 1:numclus
 for j = 1:z
     clusmean(i,j) = clusmean(i,j)/cluster(i);
 end                            
end


for i = 1:x
 for j = 1:y
  index = origimg(i, j);        
  for z = 1:3 
    %Give the mean color to each pixel
	result(i, j, z) = clusmean(index,z);
  end
 end
end

%output 
figure; 
imshow(uint8(result));      